Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 325799)
+++ channels/chan_sip.c	(working copy)
@@ -22785,9 +22785,6 @@
 		/* Fallthrough if we can't find the call leg internally */
 	}
 
-	/* Must release lock now, because it will not longer
-	   be accessible after the transfer! */
-	*nounlock = 1;
 	/*
 	 * Increase ref count so that we can delay channel destruction until after
 	 * we get a chance to fire off some events.
@@ -22798,6 +22795,7 @@
 
 	/* Parking a call */
 	if (p->refer->localtransfer && ast_parking_ext_valid(p->refer->refer_to, p->owner, p->owner->context)) {
+		ast_channel_lock(current.chan1);
 		sip_pvt_lock(p);
 		copy_request(&current.req, req);
 		ast_clear_flag(&p->flags[0], SIP_GOTREFER);
@@ -22828,6 +22826,10 @@
 		return res;
 	}
 
+	/* Must release lock now, because it will not longer
+	   be accessible after the transfer! */
+	*nounlock = 1;
+
 	/* Blind transfers and remote attended xfers */
 	if (current.chan1 && current.chan2) {
 		ast_debug(3, "chan1->name: %s\n", current.chan1->name);
